Passing a file handler and an array from Perl to Shell Script

Hi there,

I am trying to call a shell script from a Perl script. here is the code:
@args = ("sh", "someshellprg.sh", "a file handler", "an array");
system(@args) == 0
or die "system @args failed: $?";

in the shell program, I examine if the arguments exits using:

if [ $# -ne 2 ]
then echo "missing input"
exit 1
fi

the script returns "missing input", any ideas? Thanks in advance.

try something like this

$result = `sh -c someshellprg.sh a file handler  @arr`;

The 'a file handler part' makes no sense to me. You can pass the name of a (perl or shell) script, but other than that I don't get what you are trying to do.

I'm trying to call a shell script along two inputs, the first one is a file and the second is an array. I tried the code, but it didn't work. Now that you know what I'm trying to do, would you suggest a solution? Thanks.

test.pl

#!/usr/bin/perl -w
    use strict;
    my @array = (1, 2, 3, 4, 5, 6, 9);
    my $filename = "/path/to/myfilename";    
    my @args = ( "myshell.sh", "$filename", "@array");
    system(@args) == 0 || die;       

myshell.sh

echo "the filename is $1 \c"
set -A array  $2
echo  "the array = ${array[*]}"
/home/jmcnama>  test.pl
the filename is /path/to/myfilename the array = 1 2 3 4 5 6 9

It didn't work unfortunately. The array was not past over to the shell script.

I'm changing methods. The perl script calls the shell script without parameters now. It writes to a file, and the shell script reads from it. The problem now is that only one line can be read even though there are more than one line in the file, or nothing can be read. I have tried a few different ways to do it, one of them follows (it didn't read at all). I have created a file with a few lines in, and the script works fine, but it won't read more than one line if the file was generated by the perl script. Thanks!

#!/bin/bash
FILE="/home/.../somefile"

textArray[0]="" # hold text
c=0 # counter
# read whole file in loop
while read line
do
textArray[$c]=$line # store line
c=$(expr $c + 1) # increase counter by 1
done < $FILE
# get length of array
len=$(expr $c - 1 )

# use for loop to reverse the array
for (( i=0;i<$len; i++));
do
echo "make is work: ${textArray[$i]}"
done

Strange! I used the following script to see how many lines of code I have, and it says 1, but I have two lines of code.

a=0
while read line
do a=$(($a+1));
echo $a;
done < "/home/.../emailFile.txt"
echo "Final line count is: $a";